Vue

vue-apexmaps is built for Vue's own change model rather than adapted from the React wrapper. A React caller replaces options with a new object; a Vue caller mutates reactive state in place, so the last-applied options and the current props are frequently the same object. The component keeps a structural snapshot instead of a reference so that still gets noticed.

Installation

npm install apexmaps vue-apexmaps

apexmaps and vue (>=3.3.0) are peer dependencies, so there is one copy of each in your app.

Usage

<script setup>
import ApexMaps from 'vue-apexmaps'
import 'apexmaps/apexmaps.css'

const options = { geo: { map: 'world' } }
const series = [
  {
    type: 'choropleth',
    name: 'Coverage',
    data: [{ key: 'IND', value: 42 }],
    scale: { palette: 'blues', classes: 5 },
  },
]
</script>

<template>
  <ApexMaps :options="options" :series="series" :height="480" @feature-click="onClick" />
</template>

Props

PropTypeNotes
optionsApexMapsOptionsRequired. The same options object the core takes.
seriesSeries[]Optional shorthand for options.series. Takes precedence over it; both routes reach updateSeries(), so both tween.
width / heightnumber | stringShorthand for options.chart.width / .height. See Sizing below.

Anything else you bind (class, style, id, aria-*) falls through to the outer element.

Events

One event per core event, emitted under its own name, so both @feature-click and @featureClick work in a template: rendered, updated, resized, feature-click, feature-hover, feature-focus, mark-click, mark-hover, cluster-click, drilldown, drillup, selection-change, legend-toggle, zoom, pan-end.

Payload shapes for each event are documented on API: Methods and Events.

The imperative API

Camera moves, drilldown, export, and diagnostics are methods, not options. Reach them through a template ref:

<script setup>
import { useTemplateRef } from 'vue'
const el = useTemplateRef('mapEl')
const zoomToIndia = () => el.value.map.frameFeature('IND')
</script>

<template>
  <ApexMaps ref="mapEl" :options="options" />
</template>

Reactivity

Three things follow from the component being built for Vue's own change model:

Mutating in place works. options.legend.position = 'top' on reactive state is seen, because the component keeps a structural snapshot of the last-applied options rather than a reference to them. A reference would be the very object you just mutated, so every comparison would say nothing changed and the map would never update.

Reactive geometry never reaches the map. reactive() creates proxies lazily as an object is read, so a topology handed to the core would be proxied feature by feature and coordinate by coordinate as ingest walks it: tens of thousands of proxies, and a trap on every read after that. The component unwraps geo.map with toRaw and passes plain objects for everything else. markRaw on imported geometry is still worth adding yourself, so Vue never proxies it in the first place:

import { markRaw } from 'vue'
import counties from './us-counties.json'

const options = { geo: { map: markRaw(counties) } }

Deep watching stops at the geometry. Configuration is watched deeply; geo.map is watched by reference alone. Replacing it with a new object (or a different registry id) is a change; rebuilding an equal topology object on every render is also seen as a change and will reproject every time, which is the one case where the markRaw constant matters for correctness rather than speed.

Inline formatters are compared by source rather than identity, so :options="{ dataLabels: { formatter: v => `${v}%` } }" written directly in a template does not redraw on every render.

Sizing

Use the width and height props, not CSS. The map's height comes from options.chart.height, which defaults to 400; an explicit number wins over the container, so a style="height: 600px" on its own gives you a 600px box with a 400px map inside it.

Width behaves differently, because chart.width defaults to '100%': it follows the container and keeps following it as the container resizes. To have the height follow the container too, say so explicitly:

<ApexMaps :options="options" height="100%" style="height: 60vh" />

The DOM it renders

Two nested <div>s. Vue owns the outer one, where your fallthrough attributes land. ApexMaps owns the inner one and writes its own class and CSS custom properties there. Vue patches class by assigning the whole attribute, so sharing one element would mean a later class change deletes the apexmaps class and every style rule in the package stops matching.

Nuxt and SSR

Safe to import and render on the server: the component emits its container and does nothing else, because everything that touches a document happens in onMounted. It hydrates and then builds the map on the client. Wrap it in <ClientOnly> if you would rather not render the empty container at all.

React

react-apexmaps is a component around the imperative ApexMaps class. It builds the instance on mount, subscribes every core event, forwards later prop changes to updateOptions() or updateSeries(), and tears the instance down on unmount.

Installation

npm install apexmaps react-apexmaps

apexmaps and react (>=18.0.0) are peer dependencies, so there is one copy of each in your app.

Usage

import ApexMaps from 'react-apexmaps'
import 'apexmaps/apexmaps.css'

const data = [
  { key: 'IND', value: 42 },
  { key: 'BRA', value: 71 },
]

export default function Coverage() {
  return (
    <ApexMaps
      options={{ geo: { map: 'world' } }}
      series={[
        { type: 'choropleth', name: 'Coverage', data, scale: { palette: 'blues', classes: 5 } },
      ]}
      onFeatureClick={({ key }) => console.log(key)}
      height={480}
    />
  )
}

Props

PropTypeNotes
optionsApexMapsOptionsRequired. The same options object the core takes.
seriesSeries[]Optional shorthand for options.series. Takes precedence over it; both routes reach updateSeries(), so both tween.
width / heightnumber | stringShorthand for options.chart.width / .height. See Sizing below.
mapRef{ current: ApexMaps | null }Receives the live instance, for the imperative API. Nulled on unmount.
on*functionOne prop per core event, listed below.
anything elseForwarded to the outer <div>: className, style, id, aria-*.

Events

One prop per core event: onRendered, onUpdated, onResized, onFeatureClick, onFeatureHover, onFeatureFocus, onMarkClick, onMarkHover, onClusterClick, onDrilldown, onDrillup, onSelectionChange, onLegendToggle, onZoom, onPanEnd. Every core event is subscribed internally whether or not you pass a handler, and handlers are read at emit time, so an inline arrow function costs nothing and never misses an event fired between renders.

Payload shapes for each event are documented on API: Methods and Events.

The imperative API

Camera moves, drilldown, export, and diagnostics are methods, not options, because they are actions rather than state. Reach them through mapRef:

const map = useRef(null)

<ApexMaps mapRef={map} options={options} />
<button onClick={() => map.current?.frameFeature('IND')}>Zoom to India</button>
<button onClick={() => map.current?.exportPNG()}>Download</button>

Change detection

React hands the component a brand new options object on every parent render, so it compares deeply rather than by reference. Four rules in that comparison are worth knowing:

Functions compare by source, not identity. An inline formatter is a new function on every render but usually the same behavior, and treating that as a change would make every render a redraw. Editing the formatter's source is noticed; a formatter reading changed state through a closure is not, so lift such values into options where they are data.

geo.map compares by identity and is never walked. Object geometry can be megabytes, and deep-comparing it on every render would cost more than the redraw it avoids. Pass a stable reference: a module-level constant, useMemo, or a registry id string.

Series-only changes go to updateSeries(), which tweens. Everything else goes to updateOptions(), which redraws. This holds whether the data is in the series prop or in options.series.

A map or projection change reprojects; nothing else does. Camera position, selection, and drilldown depth survive an options change, so a parent re-render does not throw away where the reader had navigated to.

One thing to watch

updateOptions() merges, so removing a key from options does not reset it. This is core behavior rather than something the wrapper adds, and it does not fit a fully declarative style:

// Turning `show` off leaves the labels on, because `dataLabels` merely disappears.
options={{ ...base, ...(show && { dataLabels: { enabled: true } }) }}

// Pass the value instead of omitting the key.
options={{ ...base, dataLabels: { enabled: show } }}

Sizing

Use the width and height props, not CSS. The map's height comes from options.chart.height, which defaults to 400; an explicit number wins over the container, so a style={{ height: 600 }} on its own gives you a 600px box with a 400px map inside it.

Width behaves differently, because chart.width defaults to '100%': it follows the container and keeps following it as the container resizes. To have the height follow the container too, say so explicitly:

<ApexMaps options={options} height="100%" style={{ height: '60vh' }} />

Both props accept a number (pixels) or a CSS string; a percentage string hands the dimension to the container.

The DOM it renders

Two nested <div>s. React owns the outer one and applies your className, style, and other attributes to it. ApexMaps owns the inner one and writes its own class and CSS custom properties there. The split matters because React replaces the whole className attribute on change: sharing one element would mean a later className update deletes the apexmaps class and every style rule in the package stops matching.

Server rendering

The component is safe to import and render on the server: it emits its container and does nothing else, because everything that touches a document happens in an effect. It hydrates and then builds the map on the client. It is not server rendered, since the core has no HTML output path yet, so there is no markup to send down ahead of hydration.

Angular

ngx-apexmaps is a standalone Angular component around the imperative ApexMaps class. It is zoneless-ready: the map is built, rendered, and updated outside the Angular zone, and its outputs re-enter the zone to emit, so the same code repaints correctly in zoned and zoneless applications alike.

Installation

npm install apexmaps ngx-apexmaps

apexmaps and @angular/core (>=20.0.0) are the only peer dependencies. There is no @angular/common requirement, no rxjs requirement of its own, no zone.js requirement, and no NgModule.

Usage

import { Component, signal } from '@angular/core'
import { ApexMapsComponent } from 'ngx-apexmaps'
import 'apexmaps/apexmaps.css'

@Component({
  standalone: true,
  imports: [ApexMapsComponent],
  template: `
    <apx-map
      [options]="options"
      [series]="series()"
      [height]="480"
      (featureClick)="selected.set($event.key)"
    />
  `,
})
export class CoverageComponent {
  readonly options = { geo: { map: 'world' } }
  readonly series = signal([
    {
      type: 'choropleth',
      name: 'Coverage',
      data: [{ key: 'IND', value: 42 }],
      scale: { palette: 'blues', classes: 5 },
    },
  ])
  readonly selected = signal<string | null>(null)
}

Inputs and outputs

InputTypeNotes
optionsApexMapsOptionsRequired signal input. The same options object the core takes.
seriesSeries[]Optional signal input, shorthand for options.series. Takes precedence over it; both routes reach updateSeries(), so both tween.
width / heightnumber | stringSignal inputs, shorthand for options.chart.width / .height. See Sizing below.

One output per core event, under the core's own name: rendered, updated, resized, featureClick, featureHover, featureFocus, markClick, markHover, clusterClick, drilldown, drillup, selectionChange, legendToggle, zoom, panEnd. Each carries the payload the core emits, fully typed; see API: Methods and Events for every payload shape.

The zone contract

  • The map runs outside the Angular zone. A map attaches pointer listeners to everything it draws, and zone.js patches addEventListener, so a map built inside the zone would run change detection on every pointer movement over every feature. Construction, rendering, and updates all happen outside the zone.
  • Outputs are emitted back inside the zone. Events originate from unpatched listeners, which zone-based change detection cannot see on its own, so the component calls NgZone.run() around each emit. A (featureClick) handler that sets component state then repaints, whether the app is zoned or zoneless. Under zoneless change detection, NgZone degrades to a no-op and both calls collapse to plain function calls, so the same code is correct either way.

Measured against the built package: 30 pointer moves over the map produce zero change-detection passes; one click produces one repaint.

The imperative API

Camera moves, drilldown, export, and diagnostics are methods, not options. The component exposes the live instance as a signal, reachable through a template variable on the element:

@Component({
  template: `<apx-map #map [options]="options" />
    <button (click)="map.map()?.frameFeature('IND')">Zoom to India</button>`,
  imports: [ApexMapsComponent],
  standalone: true,
})
export class ZoomDemo {
  readonly options = { geo: { map: 'world' } }
}

map() is null until the first render completes and after destroy, so an effect() on it is the way to run something exactly once the map exists.

Change detection

Bindings are compared deeply, not by reference, because a template expression like [options]="build()" hands over a brand new object on every change-detection cycle. A fresh but equal tree is not a redraw. An inline formatter is compared by source rather than identity, and geo.map is compared by identity and never walked, so pass a stable reference or a registry id string for it. A series-only change routes to updateSeries(), which tweens; everything else routes to updateOptions(), which redraws.

Signal inputs do not fire on in-place mutation, so prefer replacing objects rather than mutating them. If some other input changes afterward, an earlier in-place mutation is picked up along with it rather than lost.

Sizing

Use the width and height inputs, not CSS. The map's height comes from options.chart.height, which defaults to 400; an explicit number wins over the container. Width defaults to '100%' and follows the container. height="100%" hands the height to the container:

<apx-map [options]="options" height="100%" style="height: 60vh" />

<apx-map> itself is display: block by default, and it is the element your class and style bindings land on. The element inside it belongs to the map.

SSR

Safe under Angular SSR and hydration: the component renders its container on the server and builds the map in afterNextRender, which only ever runs in the browser. There is no server-rendered map markup yet, because the core has no HTML output path.